from setuptools import setup, find_packages
import RansomWare

setup(
    name="RansomWare",
    version=RansomWare.__version__,
    py_modules=['RansomWare'],
    packages=find_packages(include=[]),
    install_requires=[],
    author="Maurice Lambert",
    author_email="mauricelambert434@gmail.com",
    maintainer="Maurice Lambert",
    maintainer_email="mauricelambert434@gmail.com",
    description="This package implements a cross platform RansomWare.",
    long_description=open("README.md").read(),
    long_description_content_type="text/markdown",
    include_package_data=True,
    url="https://github.com/mauricelambert/RansomWare",
    project_urls={
        "Github": "https://github.com/mauricelambert/RansomWare",
        "Documentation": "https://mauricelambert.github.io/info/python/security/RansomWare.html",
        "Python Executable": "https://mauricelambert.github.io/info/python/security/RansomWare.pyz",
        "Windows Executable": "https://mauricelambert.github.io/info/python/security/RansomWare.exe",
        "Git Windows compiled executable": "https://github.com/mauricelambert/RansomWare/releases/latest/",
        "Windows compiled executable": "https://sourceforge.net/projects/RansomWare/files/",
    },
    download_url="https://mauricelambert.github.io/info/python/security/RansomWare.pyz",
    classifiers=[
        "Topic :: System",
        "Topic :: Security",
        "Environment :: Console",
        "Operating System :: MacOS",
        "Natural Language :: English",
        "Programming Language :: Python",
        "Operating System :: POSIX :: Linux",
        "Programming Language :: Python :: 3.9",
        "Operating System :: Microsoft :: Windows",
        "Intended Audience :: System Administrators",
        "Development Status :: 5 - Production/Stable",
        "License :: OSI Approved :: GNU General Public License v3 or later (GPLv3+)",
    ],
    keywords=['RansmWare', 'CryptoLocker', 'Malware', 'CyberAttack'],
    platforms=['Windows'],
    license="GPL-3.0 License",
    entry_points={
        "console_scripts": ["RansomWare = RansomWare:cryptolocker"],
    },
    python_requires=">=3.8",
)
